<%@ page contentType="text/html"%>
<%@ page pageEncoding="UTF-8"%>
<%@ page language="java"%>
<%@ page import="java.sql.*" %>
<%@ page import="java.text.Collator.*" %>
<%@ page import="java.security.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>

<jsp:include page="header.txt" />


 <div class="mainPage">
     <p><strong>Help Documentation</strong></p>
         <ul>
             <li><a href="#NoLS">What is a NoLS?</a>
             <li><a href="#SeqSearch">Sequence-based search</a>
             <li><a href="#AccSearch">Accession-based search</a>
             <li><a href="#PredInfo">The predictor</a>
             <li><a href="#Output">Explanation of the output</a>
             <li><a href="#contacts">Contacts</a>
         </ul>

     <hr>
     <table>
         <tr><td colspan="2"><a name="NoLS"></a></td></tr>
         <tr>
             <td>
                 <b>What is a NoLS?</b>
                 <p>
                     <br>NoLSs are nucleolar localization sequences.
                     NoLSs are short basic protein motifs that localize the proteins that
                     harbour them to the <A HREF="http://www.lamondlab.com/f7nucleolus.htm">nucleolus</A>,
                     a sub-compartment of the nucleus.
                     A number of NoLSs have been experimentally identified and validated in human proteins.
                     Many of these NoLSs can target non-nucleolar reporter proteins to the nucleolus.
                 </p>

                 <p>
                     <br><a href="#top">Back to top</a>
                 </p>
             </td>
         </tr>
         <tr><td colspan="2"><a name="AccSearch"></a><hr></td></tr>
         <tr>
             <td>
                 <b>Sequence-based search</b>
                 <p>
                     <br>NoLS predictions can be obtained by pasting a protein sequence in fasta format in the input box and 
                     pressing the submit button. Optionally, users can decide to consider 
                     <a href="http://www.ncbi.nlm.nih.gov/pubmed/18463136">Jpred secondary structure prediction</a> 
                     for the prediction of NoLSs. This results in more accurate predictions but requires more computation 
                     time. If possible, full-length protein sequences should be used to obtain maximum prediction accuracy.
                     <br><br>Once the protein sequence has been submitted, a waiting page is displayed providing users with
                     a link to the output page. This link can be bookmarked and consulted later. The waiting page 
                     automatically displays the output once the prediction is completed.
                     
                     <br><br><a href="#Output">Explanation of the output</a><br>
                     
                 </p>
                 
                 <p>
                     <br><a href="#top">Back to top</a>
                 </p>
                 
             </td>
         </tr>
         <tr><td colspan="2"><a name="SeqSearch"></a><hr></td></tr>
         <tr>
             <td>
                 <b>Accession-based search</b>
                 <p>
                     <br>Our database of predicted NoLSs in human proteins can be searched
                     by entering <a href="help-ipi.jsp">IPI</a>,
                    <a href="help-refseq.jsp">RefSeq</a> or
                    <a href="help-uniprot.jsp">UniProt</a> accession numbers.
                    
                    <br><br><a href="#Output">Explanation of the output</a><br>
                 </p>
                
                 <p>
                     <br><a href="#top">Back to top</a>
                 </p>
             </td>
         </tr>
         <tr><td colspan="2"><a name="PredInfo"></a><hr></td></tr>
         <tr>             
             <td>
                 <b>The predictor</b>
                 <p>
                     <br>NoD is an artificial neural network predictor built using the
                     <A HREF="http://www.ra.cs.uni-tuebingen.de/SNNS/">Stuttgart Neural Network Simulator</A>.
                     <br>
                     NoD considers as input the protein sequence (windows of 13 residues) as well as
                     protein length, position of the window within the protein and
                     secondary structure predictions from
                     <A HREF="http://www.compbio.dundee.ac.uk/www-jpred/index.html">Jpred</A>
                     when available.
                     <br><br>
                         As shown in <a href="#fig1">Figure 1</a> and <a href="#fig2">Figure 2</a>,
                         for each 13-residue window of the protein sequence, the input
                         is encoded as a vector of 165 numerical values which are fed to the neural network,
                         which in turn generates one output value, a score s between 0 and 1.
                         This score is assigned to the middle residue of the window.
                     <br><br>
                 </p>
             </td>
         </tr>

        <tr>
             <td style="text-align: center;">
                 <img src="images/NoD_NN_small.png" border="0"/><br/>
                 Figure 1
             </td>
        </tr>
        <tr>
             <td>
                 <p>
                     All 13-residue windows of the protein sequence are assigned an output score.
                     NoLSs are predicted as regions of the protein in which at least 8 consecutive
                     windows have an average score of at least 0.8.
                     <br><br>
                 </p>
             </td>
         </tr>
         <tr>
             <td style="text-align: center;">
                 <img src="images/NoD_Prediction.png" border="0"/><br/>
                 Figure 2
             </td>
        </tr>
        <tr>
             <td>
                 <p>
                     <br><a href="#top">Back to top</a>
                 </p>
             </td>
         </tr>
         
         <tr><td colspan="2"><a name="Output"></a><hr></td></tr>
         <tr>             
             <td>
                 <b>Explanation of the output</b>
                 <p>              	
	                 <br>For proteins predicted to contain at least one NoLS, the output consists of 3 sections:</p>
	                 <ul>
	                     <li>The top section enumerates the sequences of the predicted NoLSs
	                     <li>The middle section displays the input sequence with the predicted NoLSs shown in red
	                     <li>The bottom part displays a graph of the NoLS window-based score as a function of position
	                      in the protein sequence 
	                     <br><br>
	                     Figure 3 displays typical NoD output and predictions for the protein NOL12:<br><br>
                     </ul>
             </td>
         </tr>

        <tr>
             <td style="text-align: center;">
                 <img src="images/OutputExample3.png" border="0"/><br/>
                 Figure 3
             </td>
        </tr>
        <tr>
             <td>
                 <p>
                     The score shown in the NoLS score per residue graph represents the average score of a segment of 20 
                     residues representing 8 consecutive 13-residue windows (as explained in 
                     <a href="#PredInfo">The predictor section</a>). This average score is assigned to the first residue
                     of the 20-mer and thus the graph starts at position 1 of the protein sequence.
                     <br><br>
                     The region shown in pink in this graph (the NoLS candidate signal region, which highlights scores 
                     above 0.8) represents the range of scores with which a 20 residue segment is predicted to be a NoLS.
                     <br><br>
                 </p>
             </td>
         </tr>
         
         <tr>
             <td>
                 <p>
                     <a href="#top">Back to top</a>
                 </p>
             </td>
         </tr>
         

         <tr><td colspan="2"><a name="contacts"></a><hr></td></tr>
         <tr>
             <td colspan="2">
                 <b>Contact Details</b>
                 <p>
                     If you have any problems or queries with this website, please send an email to
                        <a href="javascript:location='mailto:\u0077\u0077\u0077\u002d\u006e\u006f\u0064\u0040\u0063\u006f\u006d\u0070\u0062\u0069\u006f\u002e\u0064\u0075\u006e\u0064\u0065\u0065\u002e\u0061\u0063\u002e\u0075\u006b';void 0"><script type="text/javascript">document.write('\u0077\u0077\u0077\u002d\u006e\u006f\u0064\u0040\u0063\u006f\u006d\u0070\u0062\u0069\u006f\u002e\u0064\u0075\u006e\u0064\u0065\u0065\u002e\u0061\u0063\u002e\u0075\u006b')</script></a>
                 </p>
                 
                 <p>
                     <br><br><a href="#top">Back to top</a>
                 </p>
             </td>
         </tr>
     </table>
     <br>
 </div>
<jsp:include page="googleAnalytics.txt" />
</body>
</html>
