
<jsp:include page="header.txt" />

<link href="ws.css" rel="stylesheet" type="text/css" media=
"screen, projection, handheld, tv" />


<div class="mainPage">
<h3>NoD Virtual Appliance </h3>
<p>The NoD virtual appliance is a way to run the NoD server locally without the need 
to connect to the internet.  It is a complete and fully configured installation of 
the NoD server software on TurnKey Linux.  To run the appliance you must first 
install one of the freely available <a href="http://www.vmware.com/products/player">VMWare Player</a> 
or <a href="http://www.virtualbox.org/wiki/Downloads">Oracle VirtualBox</a> virtualisation systems. 
We have tested the NoD appliance with VMWare Player on Windows and Linux, and VirtualBox on 
Windows, Linux and Mac. On Windows and Linux we recommend  VMWare Player since it 
requires less configuration.  Mac users should use VirtualBox since the free 
VMWare player is not available on that platform.   However, you are not limited 
to these virtualization systems and can use the NoD appliance with any other virtualization 
platform.   Please note that currently, JPred secondary structure predictions are 
not available from the NoD virtual appliance. However, we are working on it.</p><br/>
     
<h4>How to install VMWare or VirtualBox</h4>
<p>Please see the  <a href="http://www.vmware.com/products/player">VMWare Player</a> 
and <a href="http://www.virtualbox.org/wiki/Downloads">Oracle VirtualBox</a> websites for up to date instructions and downloads.</p>
<br/>     
<h4><a name="whenvm" id="whenvm"></a>When to use the virtual appliance </h4>
<p>The appliance suits users who would like to use the NoD web services locally, without an Internet connection, 
or want to keep their data private. The appliance is a self contained unit of software and as such may be used from any operating system. 
The appliance comes pre-configured to use 1 CPU and 512M of  memory and the minimum amount of memory required is about 378M. </p>

<br><h4><a name="vmplayer" id="vmplayer"></a>VMware Player appliance configuration </h4>
<p>The free <a href="http://downloads.vmware.com/d/info/desktop_downloads/vmware_player/3_0">VMware Player</a> can be used to run the NoD appliance from the Windows and Linux host operating systems, there is no support for Mac at the time of writing (December 2010). However, <a href="https://www.vmware.com/vmwarestore/buyfusion.html">VMware Fusion</a>, a commercial VMware product, offers virtual machine support for Mac computers too. </p>
<p>To run the NoD server on VMware player,  unpack the NoD VM into one of the folders on your local hard drive. Open VMware Player, click &quot;Open Virtual Machine&quot; and point the Player to the location of the NoD VM, then choose the NoD.vmx file to open an appliance. </p>
<p>When you play the machine for the first time the Player might ask you whether &quot;This virtual machine may have been moved or copied.&quot;,  say that you have copied it. That is all. </p>

<br><h4><a name="virtualbox" id="virtualbox"></a>VirtualBox appliance configuration</h4>
<p>VirtualBox can be used to run NoD from Windows, Linux, Solaris or Mac host operating systems. Use the VitualBox &quot;Import  Appliance&quot; option to import the NoD appliance. Please bear in mind that to benefit from multiple CPU support under the VirtualBox software you need to enable<a href="http://en.wikipedia.org/wiki/X86_virtualization"> hardware virtualization extensions</a>, such as  Intel Virtualization VT-x or AMD-V support in the BIOS of your computer. Unfortunately, we were unable to find a reliable way to do it on Mac, so some Macs running VirtualBox will be limited to one CPU only, irrespective of the number of CPUs of the host machine. If you are in this situation you can buy the <a href="https://www.vmware.com/vmwarestore/buyfusion.html">VMware Fusion</a> to overcome these limitations.</p>
<p>We found that, by default, virtualization extensions are enabled in VirtualBox irrespective of whether your computer supports them. You will get the <a href="howto.html#vmbexc"></a><a href="#vmbexc">VERR_VMX_MSR_LOCKED_OR_DISABLED</a> exception if your computer does not support the extensions or their support is disabled. Just deselect the checkboxes shown on the screenshot below to solve the problem. </p>
<p>VirtualBox NoD VM configuration screenshot displaying virtualization settings.</p>
<p><img src="images/vmb_virtual.png" alt="VT-x extension on VirtualBox" width="662" height="507" /></p>

<br><h4><a name="jabawsAppliance" id="jabawsAppliance"/></a>NoD Appliance details</h4>
<p>By default, the NoD virtual appliance is configured with 512M of memory and 1 CPU, but you are free to change these settings. If you have more than one CPU or CPU core on your computer you can make them available for the NoD virtual machine by editing virtual machine settings. Please bear in mind that more CPU power will not make a single calculation go faster, but it will enable the VM to do calculations in parallel. Similarly, you can add more memory to the virtual machine. More memory lets your VM deal with larger tasks.</p>
<p>The VMware Player screenshot below displays NoD VM CPU settings. </p>
<p><img src="images/VMware_cpu.png" alt="vmware cpu settings" border="1" /></p>
<p><strong>NoD appliance configuration: </strong></p>
<p><strong>VMware info</strong><br />
  - Date of creation: 8 October 2010<br />
  - CPUs : 1<br />
  - RAM : 512 MB<br />
  - Networking : Host only (the VM has no access to the outside network, nothing from the outside network can access the VM)<br />
  - Hard disk : 20 GB  (expanding)<br />
  - VMware tools : Installed</p>
<p><strong>OS info</strong><br />
  - OS : TurnKey Linux, based on Ubuntu 8.0.4 JEOS (Just-Enough-Operation-System)<br />
  - Installation : Oracle Java 6, Tomcat 6, MySQL 5.0, NoD v. 1.0 <br />
  - Hostname : tomcat <br />
  - Patches : till date of creation<br />
  - IPv4 address : dhcp<br />
  - IPv6 address : auto<br />
  - DNS name : none<br />
  - Name server : dhcp<br />
  - Route : dhcp<br />
  - Keyboard : US_intl</p>
<p><strong>Login credentials</strong><br />
  - Root password: nod </p>
<p> <strong>Services</strong></p>
<ul>
  <li>Default virtual console Alt+F7 </li>
  <li>Tomcat web server. <br />
      <em>Access:</em> http://VM_IP</li>
  <li>NoD URL: http://VM_IP/nod</li>
  <li>Web Shell<br />
      <em>Access:</em> https://VM_IP:12320/</li>
  <li>Webmean<br />
      <em>Access:</em> https://VM_IP:12321/</li>
  <li>SSH/SFTP<br />
      <em>Access:</em> root@VM_IP</li>
</ul>
<p>where VM_IP is the VM IP address. Under VMware Player host only networking, the first VM may have the IP address 192.168.227.128. Under VirtualBox host only networking, the first VM may have the IP address 192.168.56.101.</p>

<br>
<h4><a name="jalviewWithJaba" id="jalviewWithJaba"></a>Accessing your NoD server VM </h4>
<p>After booting the NoD VM, you should see a similar screen (as below), however, the IP address of your VM may be different. To access your NoD just type your VM IP address and NoD context name into your browser. This information is displayed after the VM has booted up. 
The NoD address from the screenshot below is <span class="hightlight">http://192.168.227.128/nod</span><br/>Please wait for a few minutes after you see the configuration console before accessing the VM to let the server boot up completely. </p>
<p><img src="images/vm_welcome_screen.png" alt="JABAWS welcome screen" width="735" height="460" /></p>
<p>If you click on Advanced Menu, you will see the configuration console, similar to the one below. </p>
<p><img src="images/VMware_booted.png" alt="JABAWS welcome screen" width="735" height="462" /></p>
<p>If you need to configure a static IP address the configuration console will help you with this. Shutting down the VM is best from the configuration console as well.</p>


<h3>Using NoD on VM (Virtual Machine) Hints</h3>

<br/>
 <h4><a name="vmbexc" id="vmbexc"></a>VirtualBox VERR_VMX_MSR_LOCKED_OR_DISABLED exception</h4>
 <p>VERR_VMX_MSR_LOCKED_OR_DISABLED exception means that Intel Virtualization technology is disabled or not supported by your computer. If you have such a problem, please make sure you have configured the NoD VM with 1 CPU and disabled VT-X extensions. Alternatively you can enable virtualization extensions from the BIOS of your computer. Unfortunately, we cannot give you exact instructions on how to do this, as this would depend on your computer BIOS manufacturer. For MACs it may not be possible at all. </p>

 <br/>
 <h4><a name="ovfOnVmware" id="ovfOnVmware"></a>VMWare Player fails to open OVF file with "Failed to query source for information" error.</h4>
 <p>At the time of writing, the latest version of VMware Player 3.1.2 supported only a legacy OVF version 0.9, whereas OVF packaged with the NoD VM is version 1.0. Please use VMX - VMware specific configuration file with all VMware products.    </p>

 <br/>
 <h4><a name="vmiaccess" id="vmiaccess"></a>Connecting to the Internet from NoD VM.</h4>
 <p>By default the NoD VM is configured to use host-only networking. This means that the host can communicate with the VM via a network, but no other machines can. Similarly, the VM cannot communicate with any other computers apart from the host. If you want to connect to the Internet from the VM, configure your VM to use a NAT network. However, you will not be able to connect to the VM from the host in such a case. If you want to be able to connect to your VM and let the VM connect to the internet at the same time you would have to use a Bridged network. In such a case you would have to configure the VM IP address manually (unless of course your network has a DHCP server to do that). </p>

<br/>
<h4>Contact details</h4>
 <p>
  If you have any problems or queries with this website, please send an email to
  <a href="javascript:location='mailto:\u0077\u0077\u0077\u002d\u006e\u006f\u0064\u0040\u0063\u006f\u006d\u0070\u0062\u0069\u006f\u002e\u0064\u0075\u006e\u0064\u0065\u0065\u002e\u0061\u0063\u002e\u0075\u006b';void 0"><script type="text/javascript">document.write('\u0077\u0077\u0077\u002d\u006e\u006f\u0064\u0040\u0063\u006f\u006d\u0070\u0062\u0069\u006f\u002e\u0064\u0075\u006e\u0064\u0065\u0065\u002e\u0061\u0063\u002e\u0075\u006b')</script></a>
  </p>
                 
</div> <!-- content div -->
<jsp:include page="googleAnalytics.txt" />
</body>
</html>
