/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package NOD;

import java.io.PrintWriter;
import java.io.Writer;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * 
 * @author mscott
 */
public class NolsFormatter {

	private final static Logger log = Logger.getLogger(NolsFormatter.class
			.getCanonicalName());
	/* TODO move to properties */
	// private static String dbURL = "jdbc:mysql://localhost:3306";
	private static String dbURL = "jdbc:mysql://mysql.compbio.dundee.ac.uk:3306";
	private static String dbName = "nols";
	private static String dbuser = "michelle";
	private static String dbpass = "abc123";

	private final Connection conn;
	public String formattedPred;
	public String[] protSegments;
	public boolean[] nols;

	/** Creates a new instance of sanitizeInput */
	public NolsFormatter() throws Exception {

		conn = DriverManager
				.getConnection(dbURL + "/" + dbName, dbuser, dbpass);

		assert conn != null;

		Runtime.getRuntime().addShutdownHook(new Thread(new Runnable() {

			@Override
			public void run() {
				if (conn != null) {
					try {
						conn.close();
					} catch (SQLException e) {
						e.printStackTrace();
					}
				}
			}
		}));
	}

	public Connection getConnection() {
		return conn;
	}

	public void formatPredictions(String id) {
		String sqlQuery = "select count(StartPosition) from NoLS_Predictions where Protein_ID="
				+ id;
		String formattedPredictions = new String();
		int count = 0;
		int[] starts = null;
		String AA_seq = getAA_seq(id);

		try {
			Statement statement = conn.createStatement();

			ResultSet rs = statement.executeQuery(sqlQuery);

			if (rs.next()) {
				count = rs.getInt(1);
				starts = new int[count];
			}

			count = 0;
			sqlQuery = "select StartPosition from NoLS_Predictions where Protein_ID = "
					+ id + " order by StartPosition asc";
			rs = statement.executeQuery(sqlQuery);
			while (rs.next()) {
				starts[count] = rs.getInt(1) - 1; // The positions on sequences
													// in NoLS_Prediction table
													// are 1-based whereas
													// Strings in Java are
													// 0-based
				count++;
			}

			int previous_end = 0;
			int start = starts[0];
			int count_segments = 0;
			if (start > 1) {
				// nols[0] = false;
				// protSegments[0] = AA_seq.substring(1, start);
				count_segments++;
			} else {
				// nols[0] = true;
			}
			int end = start + 20;
			count = 0;

			for (int i = 1; i < starts.length; i++) {
				if (starts[i] - starts[i - 1] < 21) {
					end = starts[i] + 20;
				} else {
					if (previous_end > 0) {
						count_segments++;
					}
					// need to print out start i-1 info
					formattedPredictions += "<tt>"
							+ AA_seq.substring(start, end)
							+ "</tt> (between positions " + (start + 1)
							+ " and " + end + ")<br><br>";
					count++;
					count_segments++;

					previous_end = end;
					start = starts[i];
					end = start + 20;
				}
			}

			if (previous_end > 0) {
				count_segments++;
			}
			count_segments++;
			if (end < AA_seq.length()) {
				count_segments++;
			}

			/*
			 * formattedPredictions += "NoLS predicted between positions " +
			 * start + " and " + end + ": " + AA_seq.substring(start, end) +
			 * "<br><br>";
			 */
			formattedPredictions += "<tt>" + AA_seq.substring(start, end)
					+ "</tt> (between positions " + (start + 1) + " and " + end
					+ ")<br><br>";

			count++;

			if (count == 1) {
				formattedPredictions = "<strong>One NoLS is predicted in this protein:</strong><br><br>"
						+ formattedPredictions;
			} else {
				formattedPredictions = "<strong>"
						+ count
						+ " NoLSs are predicted in this protein:</strong><br><br>"
						+ formattedPredictions;
			}

			formattedPred = formattedPredictions;

			protSegments = new String[count_segments];
			nols = new boolean[count_segments];

			previous_end = 0;
			start = starts[0];
			count_segments = 0;
			if (start > 1) {
				nols[0] = false;
				protSegments[0] = AA_seq.substring(0, start);
				count_segments++;
			} else {
				nols[0] = true;
			}
			end = start + 20;
			for (int i = 1; i < starts.length; i++) {
				if (starts[i] - starts[i - 1] < 21) {
					end = starts[i] + 20;
				} else {
					// need to print out start i-1 info
					if (previous_end > 0) {
						protSegments[count_segments] = AA_seq.substring(
								previous_end, start);
						nols[count_segments] = false;
						count_segments++;
					}
					count++;
					nols[count_segments] = true;
					protSegments[count_segments] = AA_seq.substring(start, end);
					count_segments++;

					previous_end = end;
					start = starts[i];
					end = start + 20;
				}
			}

			if (previous_end > 0) {
				protSegments[count_segments] = AA_seq.substring(previous_end,
						start);
				nols[count_segments] = false;
				count_segments++;
			}
			// formattedPredictions += AA_seq.substring(start-1, end) +
			// " (between positions " + start + " and " + end + ")<br><br>";
			nols[count_segments] = true;
			protSegments[count_segments] = AA_seq.substring(start, end);
			count_segments++;
			if (end < AA_seq.length()) {
				nols[count_segments] = false;
				protSegments[count_segments] = AA_seq.substring(end);
				// count_segments++;
			}

			// Close the connection
			statement.close();

		} catch (SQLException msg) {
			System.out.println(msg.getMessage());
		}

		// return formattedPredictions;

	}

	public String getAA_seq(String id) {
		String sqlQuery = "select AA_sequence from Protein where ID =" + id;
		String seq = new String();
		Statement statement = null;
		try {
			statement = conn.createStatement();

			ResultSet rs = statement.executeQuery(sqlQuery);

			if (rs.next()) {
				seq = rs.getString(1);
			}

			statement.close();
			return seq;

		} catch (SQLException msg) {
			return msg.getMessage();
		}
	}

	/**
	 * Formats sequence on the JSP page
	 * 
	 * @param jspwriter
	 *            - JspWriter from the page
	 */
	public static final void formatSequence(String formattedPred,
			String[] protSegments, boolean[] nols, Writer jspwriter) {

		int previousEnd = 0;
		int maxLineLength = 60;
		int remainingOnCurrentLine;
		int remainingToPrintCount;
		String remainingToPrint;

		// boolean[] nols_positions = formatNoLSpreds.nols;
		PrintWriter writer = new PrintWriter(jspwriter);
		for (int i = 0; i < protSegments.length; i++) {
			/*
			 * if (nols_positions[i]){
			 * out.print("<FONT COLOR=\"#FF0000\">"+prot_segments[i]+"</FONT>");
			 * } else { out.print(prot_segments[i]); }
			 */

			if (nols[i]) {
				if ((previousEnd + protSegments[i].length()) < maxLineLength) {
					previousEnd += protSegments[i].length();
					writer.print("<FONT COLOR=\"#FF0000\">" + protSegments[i]
							+ "</FONT>");
				} else { // need to split onto more than one line
					remainingToPrintCount = protSegments[i].length();
					remainingToPrint = protSegments[i];
					while (remainingToPrintCount > 0) {
						remainingOnCurrentLine = maxLineLength - previousEnd;
						if (remainingOnCurrentLine > remainingToPrintCount) {
							writer.print("<FONT COLOR=\"#FF0000\">"
									+ remainingToPrint + "</FONT>");
							previousEnd += remainingToPrintCount;
							remainingToPrintCount = 0;
						} else {
							writer.print("<FONT COLOR=\"#FF0000\">"
									+ remainingToPrint.substring(0,
											remainingOnCurrentLine) + "</FONT>"
									+ "<br/>");
							remainingToPrint = remainingToPrint
									.substring(remainingOnCurrentLine);
							remainingToPrintCount = remainingToPrint.length();
							previousEnd = 0;
						}
					}
				}
				// out.print("<FONT COLOR=\"#FF0000\">"+prot_segments[i]+"</FONT>");
			} else {
				if ((previousEnd + protSegments[i].length()) < maxLineLength) {
					previousEnd += protSegments[i].length();
					writer.print(protSegments[i]);
				} else { // need to split onto more than one line
					remainingToPrintCount = protSegments[i].length();
					remainingToPrint = protSegments[i];
					while (remainingToPrintCount > 0) {
						remainingOnCurrentLine = maxLineLength - previousEnd;
						if (remainingOnCurrentLine > remainingToPrintCount) {
							writer.print(remainingToPrint);
							previousEnd += remainingToPrintCount;
							remainingToPrintCount = 0;

						} else {
							writer.print(remainingToPrint.substring(0,
									remainingOnCurrentLine) + "<br/>");
							remainingToPrint = remainingToPrint
									.substring(remainingOnCurrentLine);
							remainingToPrintCount = remainingToPrint.length();
							previousEnd = 0;
						}
					}
				}
			}
		}

	}

	/**
	 * Formats sequence on the JSP page
	 * 
	 * @param jspwriter
	 *            - JspWriter from the page
	 */
	public final void formatSequence(Writer jspwriter) {
		formatSequence(formattedPred, protSegments, nols, jspwriter);
	}

	public double[] getScores(int id) {
		double[] data = null;
		Statement st = null;
		ResultSet results = null;

		try {
			st = conn.createStatement();

			st.execute("select Seq_position,Score from NoLS_ResiduePredictions where Protein_ID="
					+ id + " order by Seq_position asc");

			results = st.getResultSet();
			if (results == null) {
				return new double[0];
			}
			int size = getResultSetSize(results);
			data = new double[size + 12];
			while (results.next()) {
				data[results.getInt(1)] = results.getFloat(2);
			}
		} catch (SQLException e) {
			log.log(Level.WARNING, e.getMessage(), e);
		} finally {
			close(results);
			close(st);
		}
		return averageValues(data);
	}

	static int getResultSetSize(ResultSet results) throws SQLException {
		results.last();
		int rowCount = results.getRow();
		results.beforeFirst();
		return rowCount;
	}

	static double[] averageValues(double[] data) {
		int consecutiveRes = 8;
		int count = 0;
		double highest_average = 0;
		double[] avg_data = new double[data.length - 21];
		for (int n = 7; n < data.length - (2 * (consecutiveRes - 1)); n++) {
			double t = 0;
			for (int j = 0; j < consecutiveRes; j++) {
				t += data[n + j];
			}
			highest_average = t / consecutiveRes;
			avg_data[n - 7] = highest_average;
			if (highest_average > 0.8) {
				// then this region is predicted to be a NoLS
				// formattedPrediction += n + "\t" + highest_average + "\n";
				count++;
			}
		}
		return avg_data;
	}

	private void close(Statement stmt) {
		if (stmt == null) {
			return;
		}

		try {
			stmt.close();
		} catch (SQLException e) {
			log.log(Level.WARNING, e.getMessage(), e);
		} finally {
			try {
				stmt.close();
			} catch (SQLException ignored) {
				// e.printStackTrace();
			}
		}
	}

	private void close(ResultSet rset) {
		if (rset == null) {
			return;
		}
		Logger log = Logger.getLogger(this.getClass().getCanonicalName());
		try {
			rset.close();
		} catch (SQLException e) {
			log.log(Level.WARNING, e.getMessage(), e);
		} finally {
			try {
				rset.close();
			} catch (SQLException ignored) {
				// e.printStackTrace();
			}
		}
	}
}
