/*
 * sanitizeInput.java
 *
 * Created on 07 December 2007, 14:32
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package NOD;

import java.io.*;
import java.util.*;
import java.sql.*;
import java.util.regex.*;


/**
 *
 * @author mmcdowall
 */
public class sanitizeInput {
    
    /** Creates a new instance of sanitizeInput */
    public sanitizeInput() {
    }
    
    
    public String cleanProtID(String hazard) {
        String clean;
        
        hazard = stripString(hazard);
        
        Pattern pName = Pattern.compile("[A-Z0-9]{3,10}");
        Pattern pIPI = Pattern.compile("IPI\\d{8}");
        Pattern pRefSeq = Pattern.compile("[N,X]P_\\d{6,9}");
        Pattern pUniProt1 = Pattern.compile("[P,Q][A-Z0-9]{5}");
        Pattern pUniProt2 = Pattern.compile("[P,Q][A-Z0-9]{5}\\-\\d");
        Pattern pUniProt3 = Pattern.compile("[P,Q][A-Z0-9]{5}\\-\\d\\d");
        Pattern pInternalID = Pattern.compile("\\d{"+hazard.length()+"}");
        
        if (hazard.length()==11) {
            Matcher matcher = pIPI.matcher(hazard);
            if (matcher.matches()) {
                clean = hazard;
            } else {
                clean = null;
            }
        } else if (hazard.length()==9 || hazard.length()==12) {
            Matcher matcher = pRefSeq.matcher(hazard);
            if (matcher.matches()) {
                clean = hazard;
            } else {
                matcher = pUniProt3.matcher(hazard);
                if (matcher.matches()) {
                    clean = hazard;
                } else {
                    clean = null;
                }
            }
        } else if (hazard.length()==6 || hazard.length()==8) {
            Matcher matcher = pUniProt1.matcher(hazard);
            if (matcher.matches()) {
                clean = hazard;
            } else {
                matcher = pUniProt2.matcher(hazard);
                if (matcher.matches()) {
                    clean = hazard;
                } else {
                    clean = null;
                }
            }
        } else {
            Matcher matcher = pInternalID.matcher(hazard);
            if (matcher.matches()) {
                clean = hazard;
            } else {
                clean = null;
            }
        }
        
        if (clean == null && hazard.length()>=3 && hazard.length()<=10) {
            Matcher matcher = pName.matcher(hazard);
            if (matcher.matches()) {
                clean = hazard;
            } else {
                clean = null;
            }
        }
        
        return clean;
    }
    
    
    public String stripString(String hazard) {
        String clean = "";
        
        String good = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_";
        
        for (int i=0; i<hazard.length(); i++) {
            if (good.indexOf(hazard.charAt(i)) >= 0) {
                clean += hazard.charAt(i);
            }
        }
        
        return clean;
    }
    
    
    public ArrayList cleanProtList(String hazard) {
        ArrayList clean = new ArrayList();
        
        String [] pL;
        String p;
        pL = hazard.split("\\s+");
        for (int i=0; i<pL.length; i++) {
            p = cleanProtID(pL[i]);
            if (p != null) {
                clean.add(p);
            } else {
                clean.add((String)"VOID");
            }
        }
        
        return clean;
    }
    
    
    public String cleanLR(String hazard) {
        String clean;
        
        if (hazard == null || hazard.compareTo("null")==0 || hazard.length()==0) {
            clean = "400";
        } else {
            Pattern pLR = Pattern.compile("\\d{"+hazard.length()+"}");
            Matcher matcher = pLR.matcher(hazard);
            if (matcher.matches()) {
                clean = matcher.group();
            } else {
                clean = "400";
            }
        }
        
        return clean;
    }
    
    
    public String cleanMod(String hazard) {
        String clean;
        
        if (hazard == null) {
            clean = "off";
        } else {
            clean = "on";
        }
        
        return clean;
    }
    
    
    public String cleanInteractions(String hazard) {
        String clean;
        
        Pattern pAll = Pattern.compile("All");
        Pattern pProt = Pattern.compile("Prot");
        
        if (hazard.length()==3) {
            Matcher matcher = pAll.matcher(hazard);
            if (matcher.matches()) {
                clean = matcher.group();
            } else {
                clean = "All";
            }
        } else if (hazard.length() == 4) {
            Matcher matcher = pProt.matcher(hazard);
            if (matcher.matches()) {
                clean = matcher.group();
            } else {
                clean = "Prot";
            }
        } else {
            clean = "All";
        }
        
        return clean;
    }
    
    
    public String cleanTag(String hazard) {
        String clean;
        
        Pattern pTag = Pattern.compile("\\w\\d{8}");
        
        if (hazard.length()==9) {
            Matcher matcher = pTag.matcher(hazard);
            if (matcher.matches()) {
                clean = matcher.group();
            } else {
                clean = "VOID";
            }
        } else {
            clean = "VOID";
        }
        
        return clean;
    }
    
    
    public String cleanImage(String hazard) {
        String clean;
        
        Pattern pImage = Pattern.compile("[\\w,\\d]{"+hazard.length()+"}");
        Matcher matcher = pImage.matcher(hazard);
        if (matcher.matches()) {
            clean = matcher.group();
        } else {
            clean = "VOID";
        }
        
        return clean;
    }
    
    
    public Integer cleanDepth(String hazard) {
        Integer clean;
        
        Integer intHazard = Integer.valueOf(hazard);
        
        if (intHazard.compareTo(Integer.valueOf(1))==0 || intHazard.compareTo(Integer.valueOf(2))==0 || intHazard.compareTo(Integer.valueOf(3))==0) {
            clean = intHazard;
        } else {
            clean = Integer.valueOf(1);
        }
        
        return clean;
    }
    
    
    public String cleanChildren(String hazard) {
        String clean;
        
        if (hazard.compareTo("true")==0 || hazard.compareTo("false")==0) {
            clean = hazard;
        } else {
            clean = "true";
        }
        
        return clean;
    }


    public String cleanFasta(String prot){
        String clean = "";
        String good = "acdefghiklmnpqrstvwyACDEFGHIKLMNPQRSTVWY";

        String[] lines = prot.split("\n");
        if (lines[0].substring(0, 1).equalsIgnoreCase(">")){
            clean = lines[0] + "\n";

            for (int j=1; j<lines.length; j++){
            	if (lines[j].substring(0, 1).equalsIgnoreCase(">")){
            		j = lines.length;
            	} else {
	                for (int i=0; i<lines[j].length(); i++) {
	                    if (good.indexOf(lines[j].charAt(i)) >= 0) {
	                        clean += lines[j].charAt(i);
	                    }
	                }
            	}
            }
        }

//        StringTokenizer tok = new StringTokenizer(prot);
//        String t, t2;
//        if (tok.hasMoreTokens()){
//            t = tok.nextToken();
//            if (t.substring(0, 1).equalsIgnoreCase(">")){
//                clean = t + "\n";
//
//                while (tok.hasMoreTokens()){
//                    t2 = tok.nextToken();
//                    for (int i=0; i<t.length(); i++) {
//                        if (good.indexOf(t2.charAt(i)) >= 0) {
//                            clean += prot.charAt(i);
//                        }
//                    }
//                }
//            }
//        }
        

        return clean;
    }
    
    
    
    /*
    public static void main(String[] args) {
        String tester = "IPI01234567 IPI09876543 NP_012345 XP_01235A P12345 P13245-5 P1D5Q25";
        ArrayList prot = cleanProtList(tester);
        for (int i=0; i<prot.size(); i++) {
            System.out.println((String)prot.get(i));
        }
    }
    */
}
